Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2475 by niro, Wed Jan 8 08:59:52 2014 UTC revision 2654 by niro, Thu Jul 3 08:24:39 2014 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 72  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75    ### helper scripts ###
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 88  trap_exit() Line 86  trap_exit()
86   exit 1   exit 1
87  }  }
88    
 dialog_die()  
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 task_setup_system_menu()  
 {  
  local mode  
  local retval  
   
  mode="$(dialog_setup_system_menu)"  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") task_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"  
  fi  
   
  messagebox -y 12 -h $"Detected hardware:" "${message}"  
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manual  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
89  install_meter()  install_meter()
90  {  {
91   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
# Line 228  install_meter() Line 99  install_meter()
99   return 0   return 0
100  }  }
101    
102  dialog_main()  mount_rootfs()
103  {  {
  local method=0  
104   local retval   local retval
105    
106   while [[ ${method} -le 2 ]]   if is_mounted --location "${INSTALLROOT}"
107   do   then
108   method=$(CANCEL_LABEL=$"Exit" menubox $"Configuration:" \   echo $"${INSTALLROOT} already mounted" >&2
109   $"1:Install system" \   else
110   $"2:Show detected harddrives" \   mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
111   $"3:Exit and reboot" \   fi
112   $"4:Exit and drop into a shell")   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
113   retval=$?  }
114   [[ ${retval} -eq 1 ]] && exit 1  
115   if [[ ${retval} -eq 0 ]]  umount_rootfs()
116   then  {
117   case ${method} in   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
118   "1") task_setup_system_menu ;;   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
119   "2") dialog_hardware_detection ;;  }
120   "3") install_do_reboot ;;  
121   "4") /bin/bash --login -i ;;  install_do_reboot()
122   esac  {
123   fi   reboot
  done  
124  }  }
125    
 #################################################  
 # Install Komandos #  
 #################################################  
126  run_hardware_detection()  run_hardware_detection()
127  {  {
128   local hwinfo   local hwinfo
129    
130   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
131    
132   ## check for special devices/clients:   # check for special devices/clients:
133   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
134   #local removable=0   local removable=0
135   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
136   #then   then
137   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
138   #do   #do
139   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
140   #then   # then
141   #removable=1   # removable=1
142   #fi   # fi
143   #done   #done
144   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
145    
146   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
147   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
148   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
149   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
150   #then   then
151   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
152   #else   else
153   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
154   #fi   fi
155   #fi   fi
156    
157   # check for special devices/clients:   # check for special devices/clients:
158   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 322  run_hardware_detection_disks() Line 188  run_hardware_detection_disks()
188   # all disks but exclude ramdisks   # all disks but exclude ramdisks
189   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
190   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
191   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
192   then   then
193   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
194   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
195   fi   fi
196   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
197  }  }
198    
 hdd_size_below_256mb()  
 {  
  local hdd="$1"  
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
   
  size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')  
  if [[ ${size} -le 257000000 ]]  
  then  
  retval="0"  
  else  
  retval="1"  
  fi  
   
  return "${retval}"  
 }  
   
199  setup_hdd_partitions_auto()  setup_hdd_partitions_auto()
200  {  {
201   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
# Line 362  setup_hdd_partitions_auto() Line 210  setup_hdd_partitions_auto()
210   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
211   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
212   then   then
213   if hdd_size_below_256mb ${HDD}   if device_minimum_size "${HDD}" 256
214   then   then
215   FDISKPARTIONBELOW256MB=1   FDISKPARTIONBELOW256MB=1
216   else   else
# Line 437  setup_hdd_format() Line 285  setup_hdd_format()
285   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
286  }  }
287    
 install_mount_rootfs()  
 {  
  is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
  install -d ${INSTALLROOT}/boot || dialog_die  
 }  
   
288  install_system_image()  install_system_image()
289  {  {
290   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
291   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}}/${CDIMAGENAME} -C ${INSTALLROOT}
292   popd > /dev/null   popd > /dev/null
293  }  }
294    
295  disabled_install_bootsector_chroot()  install_system_settings()
296  {  {
297   local my_roothdd   local CONFIG
  local grubconf="${INSTALLROOT}/boot/grub/grub.conf"  
  local grub2conf="/boot/grub/grub.cfg"  
298    
299   # check for grub2   # write fstab
300   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/fstab"
301     clearconfig
302     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
303     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
304     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
305    
306     # install network config skeleton
307     CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
308     clearconfig
309     addconfig 'ONBOOT="yes"'
310     addconfig 'NETWORKING="dhcp"'
311    
312     # intel framebuffer quirk
313     CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
314     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
315   then   then
316   # needed by grub-mkconfig on the first run   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
317   then   then
318   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
319     [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
320   fi   fi
321     fi
322    }
323    
  # set kernelopts  
  if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]  
  then  
  sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  else  
  CONFIG="${INSTALLROOT}/etc/conf.d/grub"  
  clearconfig  
  addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""  
  fi  
  CONFIG="${INSTALLROOT}/root/.installrc"  
  clearconfig  
  # only grub 1.99  
  addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'  
  addconfig "grub-install --no-floppy ${HDD} &> /dev/null"  
  addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null"  
  addconfig "exit 0"  
324    
325   # grub-legacy  ### installer dialogs ###
  else  
  source ${INSTALLROOT}/boot/kernelversion  
326    
327   if [ -e ${INSTALLROOT}/etc/alx_version ]  dialog_die()
328   then  {
329   OLD_ALXVER="${ALXVER}"   ERROR="$1"
330   source ${INSTALLROOT}/etc/alx_version   RETVAL="$?"
331   KRNVER="ALX-${ALXVER}"   dialog_install_failure
332   ALXVER="${OLD_ALXVER}"   exit 1
333   fi  }
334    
335   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  dialog_warning()
336   [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  {
337   [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"   local retval
   
  # uuid support  
  my_roothdd="UUID=$(get_uuid ${ROOTHDD})"  
   
  CONFIG="${grubconf}"  
  clearconfig  
  addconfig "default 0"  
  addconfig "timeout 3"  
  # using current root password  
  addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  
   
  addconfig  
  addconfig "# normal boot"  
  addconfig "title ${KRNVER}"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"  
  if is_initrd_supported  
  then  
  addconfig "initrd /boot/${KRNINITRD}"  
  fi  
338    
339   addconfig   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
340   addconfig "# admin boot"   retval=$?
341   addconfig "title ${KRNVER} - Re-run hardware-detection"   if [[ ${retval} -eq 1 ]]
342   addconfig "lock"   then
343   addconfig "root (hd0,0)"   clear
344   addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"   echo $"The process was aborted."
345   if is_initrd_supported   exit 1
346   then   fi
347   addconfig "initrd /boot/${KRNINITRD}"  }
  fi  
348    
  addconfig  
  addconfig "title ${KRNVER} - Reset *all* local settings"  
  addconfig "lock"  
  addconfig "root (hd0,0)"  
  addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"  
  if is_initrd_supported  
  then  
  addconfig "initrd /boot/${KRNINITRD}"  
  fi  
349    
350   # bootsector schreiben chrooted schreiben (lfs/magellan)  ### installer tasks ###
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  
 root (hd0,0)  
 setup (hd0)  
 quit  
 EOF  
 exit 0  
 CHROOTEOF  
  fi  
351    
352   # run installrc  task_setup_system_menu()
353   chrooted /bin/bash --rcfile /root/.installrc -i  {
354   rm ${INSTALLROOT}/root/.installrc   local mode
355  }   local retval
   
 disabled_install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
356    
357   if [[ ${FORMFACTOR} = laptop ]]   mode="$(dialog_setup_system_menu)"
358     retval=$?
359     [[ ${retval} -eq 1 ]] && return 1
360     if [[ ${retval} -eq 0 ]]
361   then   then
362   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   case "${mode}" in
363     "1") run_install_auto ;;
364     "2") run_install_normal ;;
365     "") task_setup_system_menu;;
366     esac
367   fi   fi
368    }
369    
370   # install an appropriate uvesafb.conf  task_hardware_detection()
371   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  {
372   CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"   local message
  clearconfig  
  addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"  
373    
374   # install an appropriate viafb.conf   run_hardware_detection_disks
  CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"  
  clearconfig  
  addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"  
375    
376   # install an appropriate i810fb.conf   message+=$"Harddrives:\n"
  CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"  
  clearconfig  
  addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  
377    
378   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   if [[ ! -z ${ALL_DISKS} ]]
379  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   then
380  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null   for i in ${ALL_DISKS}
381  exit 0   do
382  CHROOTEOF   message+="\Z3${i}\Zn "
383     done
384     message+="\n"
385     fi
386    
387   # run installrc   if [[ ! -z ${ALL_CDROMS} ]]
388   chrooted /bin/bash --rcfile /root/.installrc -i   then
389   rm ${INSTALLROOT}/root/.installrc   message+="\n"
390  }   message+=$"Optical disk drives:\n"
391     for i in ${ALL_CDROMS}
392     do
393     message+="\Z3${i}\Zn"
394     done
395     message+="\n"
396     fi
397    
398  install_system_settings()   # other devices
399  {   run_hardware_detection
400   local CONFIG   case "${SPECIALDEVICE}" in
401     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
402     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
403     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
404     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
405     esac
406     if [[ ${FORMFACTOR} = laptop ]]
407     then
408     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
409     fi
410    
411   # write fstab   messagebox -y 12 -h $"Detected hardware:" "${message}"
412   CONFIG="${INSTALLROOT}/etc/fstab"  }
  clearconfig  
  addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"  
  addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"  
  addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"  
413    
414   # install network config skeleton  task_setup_hdd_partitions_manual()
415   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"  {
416   clearconfig   local i
417   addconfig 'ONBOOT="yes"'   local retval
  addconfig 'NETWORKING="dhcp"'  
418    
419   # intel framebuffer quirk   if [[ -z ${ALL_DISKS} ]]
  if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]  
420   then   then
421   if [ -e /proc/fb ]   dialog_no_harddrive_found
422     exit 1
423     else
424     HDD=$(dialog_select_target_harddrive)
425     retval=$?
426     [[ ${retval} -eq 1 ]] && return 1
427     if [[ ${retval} -eq 0 ]]
428   then   then
429   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   dialog_setup_hdd_info
430   then   setup_hdd_partitions_manual
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
431   fi   fi
432   fi   fi
433  }  }
434    
435  install_umount_rootfs()  task_setup_hdd_partitions_auto()
436  {  {
437   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   local i
438   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   local retval
439    
440     if [[ -z ${ALL_DISKS} ]]
441     then
442     dialog_no_harddrive_found
443     exit 1
444     else
445     HDD=$(dialog_select_target_harddrive)
446     retval=$?
447     [[ ${retval} -eq 1 ]] && return 1
448     if [[ ${retval} -eq 0 ]]
449     then
450     dialog_setup_hdd_info_auto
451     dialog_setup_hdd_create_partitions
452     setup_hdd_partitions_auto
453     fi
454     fi
455  }  }
456    
457  install_do_reboot()  task_main()
458  {  {
459   reboot   local method=0
460  }   local retval
461    
462  #################################################   while [[ ${method} -le 2 ]]
463  #     Install Ablauf Scripte #   do
464  #################################################   method=$(dialog_main)
465     retval=$?
466     [[ ${retval} -eq 1 ]] && exit 1
467     if [[ ${retval} -eq 0 ]]
468     then
469     case ${method} in
470     "1") task_setup_system_menu ;;
471     "2") task_hardware_detection ;;
472     "3") install_do_reboot ;;
473     "4") /bin/bash --login -i ;;
474     esac
475     fi
476     done
477    }
478    
479  run_install_normal()  run_install_normal()
480  {  {
481   dialog_hardware_detection   task_hardware_detection
482    
483   dialog_setup_hdd_partitions_manual   task_setup_hdd_partitions_manual
484   dialog_setup_hdd_format   dialog_setup_hdd_format
485   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
486   install_mount_rootfs   mount_rootfs
487   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
488    
489   dialog_install_settings   dialog_install_settings
# Line 681  run_install_normal() Line 500  run_install_normal()
500   bootloader_config   bootloader_config
501   bootloader_install   bootloader_install
502    
503   install_umount_rootfs   umount_rootfs
504   dialog_install_successful   dialog_install_successful
505  }  }
506    
507  run_install_auto()  run_install_auto()
508  {  {
509   dialog_hardware_detection   task_hardware_detection
510    
511   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
512   dialog_setup_hdd_format   dialog_setup_hdd_format
513   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
514   install_mount_rootfs   mount_rootfs
515   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
516    
517   dialog_install_settings   dialog_install_settings
# Line 709  run_install_auto() Line 528  run_install_auto()
528   bootloader_config   bootloader_config
529   bootloader_install   bootloader_install
530    
531   install_umount_rootfs   umount_rootfs
532   dialog_install_successful   dialog_install_successful
533  }  }
534    
535  # set some proper traps  # set some proper traps
536  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
537    
538  dialog_main  task_main
539    
540  exit 0  exit 0

Legend:
Removed from v.2475  
changed lines
  Added in v.2654